#!/usr/bin/env python

try:
    import sqlite3
except:
    print "You need to install python-sqlite3"
    
try:
    import base64
except:
    print "You need python-base64 installed"

conn = sqlite3.connect('data/snippets.db')

def storedb(cat_id, title, snipet, language, comment):
    try:
        c = conn.cursor()
        snippet = base64.encodestring(snipet)
        c.execute(("""insert into snippets('cat_id', 'name', 'snippet', 'language', 'comment') values ('%s', '%s', '%s', '%s', '%s')""" % (cat_id, title, snippet, language, comment.replace("'", "\''").replace('"', '\""'))))
        conn.commit()
        c.close()
        return 1
    except:
        return 0

def get_snip_fromdb(snipid):
    try:
        c = conn.cursor()
        results = c.execute("""select snippet, comment, language from snippets where name like '%s'""" % (snipid))
        c.close()
        return results
    except:
        return 0
    
def delete_snip(snipid):
    try:
        c = conn.cursor()
        c.execute("""delete from snippets where name = '%s'""" % snipid)
        conn.commit()
        c.close()
        return 1
    except:
        return 0
    
def get_snip_name(snipid):
    try:
        c = conn.cursor()
        results = c.execute("""select name from snippets where id = %s""" % snipid)
        for result in results:
            return result[0]
    except:
        return None
    
def get_cats():
    try:
        c = conn.cursor()
        return c.execute("""select name from categories""")
    except:
        return 0
    
def get_langs():
    try:
        c = conn.cursor()
        return c.execute("""select language from languages""")
    except:
        return 0
    
def get_langid(lang):
    if check_db_langs(lang) == None:
        store_lang(lang)
    c = conn.cursor()
    langid = c.execute("""select id from languages where language = '%s'""" % lang)
    for id in langid:
        return id[0]
    
    
def store_lang(lang):
    c = conn.cursor()
    c.execute("""insert into languages('language') values ('%s')""" % lang)
    conn.commit()
    c.close()
    
def check_db_langs(lang):
    c = conn.cursor()
    langid = c.execute("""select id from languages where language like '%s'""" % lang)
    for ids in langid:
        return ids[0]
